commit 402d57846c9acca15ff80e192e3ede1f179eb8f2
Author: Patrick Palka <ppalka@redhat.com>
Date:   Tue Oct 14 18:56:23 2025

    c++: mem-initializer-id qualified name lookup is type-only [PR122192]
    
    Since a mem-initializer needs to be able to initialize any base class,
    lookup for which is type-only, we in turn need to make mem-initializer-id
    qualified name lookup type-only too.
    
            PR c++/122192
    
    gcc/cp/ChangeLog:
    
            * parser.cc (cp_parser_mem_initializer_id): Pass class_type
            instead of typename_type to cp_parser_class_name in the
            nested-name-specifier case.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/template/dependent-base6.C: Verify mem-initializer-id
            qualified name lookup is type-only too.
    
    Reported-by: Vincent X
    Reviewed-by: Jason Merrill <jason@redhat.com>
    (cherry picked from commit 97da8fece19caf0277c2be523520d09252821973)

diff --git a/gcc/cp/parser.cc b/gcc/cp/parser.cc
index d5ba1bf3c1c..c208e3862e7 100644
--- a/gcc/cp/parser.cc
+++ b/gcc/cp/parser.cc
@@ -18374,7 +18374,7 @@ cp_parser_mem_initializer_id (cp_parser* parser)
     return cp_parser_class_name (parser,
 				 /*typename_keyword_p=*/true,
 				 /*template_keyword_p=*/template_p,
-				 typename_type,
+				 class_type,
 				 /*check_dependency_p=*/true,
 				 /*class_head_p=*/false,
 				 /*is_declaration=*/true);
